// DCC Decoder for DS-DCC decode
// By yaasan
// Based on Nicolas's sketch http://blog.nicolas.cx
// Inspired by Geoff Bunza and his 17 Function DCC Decoder & updated library
//
//
//

//#define _BEMF             // BEMFを有効にする

/*************************************************
 * 
 * Declaration of Symbols
 * 
 * for AYA020-2 Smile Motor Bipolar Decoder
 * 2018/6/30 aya add , 2018/10/15 modified twaydcc
 *
 *************************************************/

/*************************************************
 * 
 * Declaration of Classes
 * 
 *************************************************/

/*************************************************
 * 
 * Declaration of Variables
 * 
 *************************************************/


typedef struct _MOTOR_PARAM
{
	byte mStartVoltage;
	byte mMaxVoltage;
	byte mAccRatio;
	byte mDecRatio;
	byte mBEMFcoefficient;
	byte mPI_P;	
	byte mPI_I;	
	byte mBEMFcutoff;
} MOTOR_PARAM;


#if defined(__AVR_ATtiny85__)
 //http://www.technoblogy.com/show?LE0
 const int pwm_MR = 0; // FWR
 const int pwm_ML = 1; // REV
#else
 #define _DSFOX
 const int pwm_MR = 11;
 const int pwm_ML = 3;
#endif


/*************************************************
 * 
 * Declaration of Functions
 * 
 *************************************************/

extern void MOTOR_Init();
extern void MOTOR_SetCV(byte iNo, byte inData);
extern void MOTOR_Sensor();
extern void MOTOR_Ack(void);
extern void MOTOR_SetDir(uint8_t inDir);
extern int MOTOR_Main(int inSpeedCmd, uint8_t *inDirection);
int MOTOR_limitSpeed(int inSpeed);
int MOTOR_GetBEMF();

void pwmWrite(int motor, int intensity);

extern byte MOTOR_GetDirection();
